/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the List type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &List{}

// List struct for List
type List struct {
	ButtonName string `json:"button_name"`
	Items []MessageItem `json:"items"`
}

// NewList instantiates a new List object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewList(buttonName string, items []MessageItem) *List {
	this := List{}
	this.ButtonName = buttonName
	this.Items = items
	return &this
}

// NewListWithDefaults instantiates a new List object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListWithDefaults() *List {
	this := List{}
	return &this
}

// GetButtonName returns the ButtonName field value
func (o *List) GetButtonName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ButtonName
}

// GetButtonNameOk returns a tuple with the ButtonName field value
// and a boolean to check if the value has been set.
func (o *List) GetButtonNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ButtonName, true
}

// SetButtonName sets field value
func (o *List) SetButtonName(v string) {
	o.ButtonName = v
}

// GetItems returns the Items field value
func (o *List) GetItems() []MessageItem {
	if o == nil {
		var ret []MessageItem
		return ret
	}

	return o.Items
}

// GetItemsOk returns a tuple with the Items field value
// and a boolean to check if the value has been set.
func (o *List) GetItemsOk() ([]MessageItem, bool) {
	if o == nil {
		return nil, false
	}
	return o.Items, true
}

// SetItems sets field value
func (o *List) SetItems(v []MessageItem) {
	o.Items = v
}

func (o List) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o List) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["button_name"] = o.ButtonName
	toSerialize["items"] = o.Items
	return toSerialize, nil
}

type NullableList struct {
	value *List
	isSet bool
}

func (v NullableList) Get() *List {
	return v.value
}

func (v *NullableList) Set(val *List) {
	v.value = val
	v.isSet = true
}

func (v NullableList) IsSet() bool {
	return v.isSet
}

func (v *NullableList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableList(val *List) *NullableList {
	return &NullableList{value: val, isSet: true}
}

func (v NullableList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


